  class CGIContext
    include DRbUndumped
    attr_accessor :content
    def initialize(cgi)
      @cgi = cgi
      @cookies = []
      @header = {}
    end
    def req_params
      @cgi.params
    end
    def req_cookie(name)
      @cgi.cookies[name][0]
    end
    def req_cookies
      hash = {}
      @cgi.cookies.each{|k,v| hash[k] = v[0] }
      hash
    end
    def res_add_cookie(name, value, expires=nil)
      cookie = CGI::Cookie.new(name, value)
      cookie.expires = expires if expires
      @cookies.push cookie
    end
    def close
      @header['cookie'] = @cookies
      @header['charset'] = 'Shift_JIS'
#     @header['content-length'] = @content.size.to_s
      @header['pragma'] = 'no-cache'
      @header['cache-control'] = 'no-cache'
      @cgi.out(@header) { @content }
    end
    def req_path_info
      @cgi.path_info
    end
    def req_script_name
      @cgi.script_name
    end
    def req_query_string
      @cgi.query_string
    end
    def req_meta_vars
      meta = {}
      for env in %w[ AUTH_TYPE CONTENT_TYPE GATEWAY_INTERFACE PATH_INFO
          PATH_TRANSLATED QUERY_STRING REMOTE_ADDR REMOTE_HOST
          REMOTE_IDENT REMOTE_USER REQUEST_METHOD SCRIPT_NAME
          SERVER_NAME SERVER_PROTOCOL SERVER_SOFTWARE
          HTTP_ACCEPT HTTP_ACCEPT_CHARSET HTTP_ACCEPT_ENCODING
          HTTP_ACCEPT_LANGUAGE HTTP_CACHE_CONTROL HTTP_FROM HTTP_HOST
          HTTP_NEGOTIATE HTTP_PRAGMA HTTP_REFERER HTTP_USER_AGENT ]
        meta[env] = @cgi.send(env.sub(/^HTTP_/n, '').downcase)
      end
      meta
    end
  end

