require 'check'
require 'listpd'
class CheckProducer < ListProducer
  set_erb('check.erb')
  self.field_name = Check::Item.field_name
  self.field_caption = {
    :todo => "",
    :person => "",
    :value => "o",
    :note => "`",
  }
  self.caption = 'o'
  def do_mail(context, params)
      todo_key, = params['todo']
      @todo_key = todo_key
      @mode = :mail
  end
  def do_sendmail(context, params)
      sendmail(context, params, @todo_key)
      @mode = :browse
  end
  def check(key, value, note)
    @list.edit(key, nil, nil, value, note)
  end
  def do_check(context, params)
      key, = params['key']
      @currkey = key
      @mode = :check
  end
  def do_edit(context, params)
      key, = params['key']
      value, = params['value']
      note, = params['note']
      check(key, value, note)
      @mode = :browse
  end
require 'thread' # for Mutex
  def initialize(session, check, todo, person)
    super(session, check)
    @mutex = Mutex.new
    @todo = todo
    @person = person
    @field_ref = {
      :todo => [@todo, :date, :subject],
      :person => [@person, :name],
    }
  end
  def sendmail(context, params, todo_key)
    @action = 'http://' +
        String(context.req_meta_vars['HTTP_HOST']) +
        String(context.req_script_name) +
        String(context.req_path_info)
@mutex.synchronize do
    @todo.edit(todo_key, nil, nil, nil, nil, '1')
    pool = []
    @list.fetch_hash_all do |i|
      pool.push i if i[:todo] == todo_key
    end
    @person.fetch_hash_all do |person_item|
      person_key = person_item[:key]
      item = pool.find do |i|
        i[:person] == person_key
      end
      item ||= @list.add(todo_key, person_key, '', '').to_hash
      mail = person_item[:mail]
      open("sendmail.log", "ab") do |f|
        f.print <<EOT
To: #{mail}

#{params['text']}
omF: #{href('check', {'key'=>item[:key]})}
EOT
      end
    end
end # synchronize
  end
  def do_select(context, params)
    name, = params['name']
    value, = params['value']
    name = name.intern
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			ref_item = prod.fetch_hash(value)
			ref_name_list.each do |ref_name|
				@selector.store(ref_name, ref_item[ref_name])
			end
			return
		end
    @selector.store(name, value)
  end

def field_producer(id)
	producer = self
	self.class.field_name.each do |name|
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			if ref_name_list.include?(id)
				producer = prod
				break
			end
			next
		end
		break
	end
	producer
end
def field_caption(name)
p [	field_producer(name).class, name]
	field_producer(name).class.field_caption[name]
end
def field_name_count
	count = 0
	self.class.field_name.each do |name|
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			count += ref_name_list.size
			next
		end
		count += 1
	end
	count
end
def get_field_name
	ret = []
	self.class.field_name.each do |name|
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			ret.push(*ref_name_list)
			next
		end
		ret.push name
	end
	ret
end
def field_name_each
	self.class.field_name.each do |name|
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			ref_name_list.each do |ref_name|
				yield ref_name
			end
			next
		end
		yield name
	end
end
def field_name_caption_each
	self.class.field_name.each do |name|
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			ref_name_list.each do |ref_name|
				yield ref_name, prod.class.field_caption[ref_name]
			end
			next
		end
		yield name, self.class.field_caption[name]
	end
end
def field_name_value_each(item)
	self.class.field_name.each do |name|
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			ref_item = prod.fetch_hash(item[name])
			ref_name_list.each do |ref_name|
				yield ref_name, ref_item[ref_name]
			end
			next
		end
		yield name, item[name]
	end
end

end
